/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package componentes;

/**
 *
 * @author jonas.schiefner
 */
public class ResultadoTransaccion {
    public enum ErrorType {
        FALTA_NOMBRE_TITULAR,
        IBAN_INVALIDO,
        FALTA_CUENTA,
        MISMO_CUENTA,
        FALTA_CONCEPTO,
        FALTA_SALDO,
        SALDO_INVALIDO,
        NO_CUBRE_SALDO
    }
    
    private int saldoTransaccion;
    private int saldoRestante;
    private ErrorType error;
    
    public ResultadoTransaccion(ErrorType error) {
        this.error = error;
    }
    
    public ResultadoTransaccion(int saldoTransaccion, int saldoRestante) {
        this.saldoTransaccion = saldoTransaccion;
        this.saldoRestante = saldoRestante;
    }
    
    public ResultadoTransaccion(ErrorType error, int saldoTransaccion, int saldoRestante) {
        this(error);
        this.saldoTransaccion = saldoTransaccion;
        this.saldoRestante = saldoRestante;
    }
    
    public Boolean isExito() {
        return error == null;
    }
    
    public String getMensage() {
        if (error == null) {
            return "¡Hecho! ha transferido " + saldoTransaccion + "€ y tu saldo es ahora de " + saldoRestante + "€";
        }
        
        switch (error) {
            case FALTA_NOMBRE_TITULAR -> {
                return "Tiene que rellenar el campo \"Nombre Titular\"";
            }
            case IBAN_INVALIDO -> {
                return "IBAN inválido";
            }
            case FALTA_CUENTA -> {
                return "No se ha podido encontrar una cuenta con este id";
            }
            case MISMO_CUENTA -> {
                return "N1o puede transferir a su propia cuenta";
            }
            case FALTA_CONCEPTO -> {
                return "Tiene que rellenar el campo \"Concepto\"";
            }
            case FALTA_SALDO -> {
                return "Tiene que rellenar el campo \"Saldo\"";
            }
            case SALDO_INVALIDO -> {
                return "El saldo debe ser un número entero mayor que cero";
            }
            case NO_CUBRE_SALDO -> {
                return "Su cuenta no cubre el saldo de " + saldoTransaccion + "€. Tiene solo " + saldoRestante + "€";
            }
            default -> {
                return "Error internal";
            }
        }
    }
}
