/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package componentes;

import javax.swing.JFrame;
import modelo.Cuenta;
import vista.VistaCajero;
import vista.VistaCambiarPin;
import vista.VistaLogin;
import vista.VistaTransacciones;

/**
 *
 * @author jonas.schiefner
 */
public class StateMachine {
    private JFrame currentState;
    private Cuenta modelo;
    private VistaLogin vistaLogin;
    
    public StateMachine() {
        // TODO change back
        abrirVentanaLogin();
    }
    
    private void disposeCurrentVista() {
        if (currentState!=null){
            currentState.setVisible(false);
            currentState.dispose();
        }
    }
    
    public void abrirVentanaLogin() {
        java.awt.EventQueue.invokeLater(() -> {
            disposeCurrentVista();
            currentState = new VistaLogin(modelo);
            currentState.setVisible(true);
        });
    }
    
    
    public void abrirVistaCambiarPin(Cuenta cuenta) {   
        java.awt.EventQueue.invokeLater(() -> {
            disposeCurrentVista();
            this.modelo = cuenta;
            currentState = new VistaCambiarPin(modelo);
            currentState.setVisible(true);
        });
    }
    
    public void abrirVistaTransacciones(Cuenta cuenta) {
        java.awt.EventQueue.invokeLater(() -> {
            disposeCurrentVista();
            this.modelo = cuenta;
            currentState = new VistaTransacciones(modelo);
            currentState.setVisible(true);
        });
    }
    
    public void abrirVistaCajero(Cuenta cuenta) {
        java.awt.EventQueue.invokeLater(() -> {
            disposeCurrentVista();
            this.modelo = cuenta;
            currentState = new VistaCajero(modelo);
            currentState.setVisible(true);
            
        });
    }
    
        
}
