/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package controlador;


import modelo.Cuenta;
import vista.VistaCajero;

/**
 *
 * @author pablo
 */
public class ControladorCajero {
    private final VistaCajero vistaCajero;
    private Cuenta cuenta;
   
    
    public ControladorCajero(VistaCajero vista, Cuenta cuenta){
        this.vistaCajero = vista;
        this.cuenta = cuenta;
    }
    
    
    public void saldo(Cuenta cuenta){
        vistaCajero.setSaldo(cuenta.getSaldo()+"€");
    }
    
    /**
     * Metodo utilizado para retirar dinero de la cuenta
     * @param cuenta la cuenta de la que se desea retirar dinero
     */
    public void retirar(Cuenta cuenta){
        String dineroRetirarText = vistaCajero.getRetirarDinero();
        int dineroRetirar = Integer.parseInt(dineroRetirarText);
        
        if(dineroRetirar<=cuenta.getSaldo() && dineroRetirar>0){
            if(!noMultiploDeDiez(dineroRetirarText)){
                cuenta.retirarDineroCajero(cuenta,dineroRetirar);
                vistaCajero.setSaldoRetirar(cuenta.getSaldo()+"€");
            }else{
                vistaCajero.setSaldoRetirar("EL DINERO DESEADO NO ES MULTIPLO DE 10");
            }        
        }else{
                vistaCajero.setSaldoRetirar("NO HAY SALDO (ERROR)");
        }
       
    }
    
    /**
     * Para saber si un saldo es un multiple de 10 o no
     * @param saldo un string saldo
     * @return si el saldo es un multiple de 10 o no
     */
    public static Boolean noMultiploDeDiez(String saldo){
       int saldoNum = Integer.parseInt(saldo);
       int multiplo = saldoNum % 10;
       return multiplo != 0;
    }
}
