package modelo;

import java.time.LocalDate;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import vista.VistaCajero;

/**
 *
 * @author jonas.schiefner
 */
public class Cuenta {
    private String pin;
    private int saldo;
    private String iban;
    List<Transaccion> transaccionesInicializadas;
    List<Transaccion> transaccionesEntrantes;
    List<String> listaRetirarDinero = new ArrayList<>();     
    private VistaCajero vistaCajero;
    
    public Cuenta(String pin, int saldo, String iban) {
        this.pin = pin;
        this.saldo = saldo;
        this.iban = iban;
        this.transaccionesInicializadas = new ArrayList<Transaccion>();
        this.transaccionesEntrantes = new ArrayList<Transaccion>();
        listaRetirarDinero.add("Sacaste 200€, el 2022-02-12"+"\n"); 
        listaRetirarDinero.add("Sacaste 100€, el 2022-01-10"+"\n"); 
    }
    
    public String getPin() {
        return pin;
    }
    
    public int getSaldo() {
        return saldo;
    }
    
    public String getIban() {
        return iban;
    }
    
    public List<Transaccion> getTransaccionesInicializadas() {
        return transaccionesInicializadas;
    }
    
    public List<Transaccion> getTransaccionesEntrantes() {
        return transaccionesEntrantes;
    }
    
    public List<String> getlistaRetirarDinero(){ 
        return listaRetirarDinero;                  
    }                                               
    
    public void setPin(String pin) {
        this.pin = pin;
    }
    
    public void retirarDinero(int saldo) {
        Transaccion transaccion = new Transaccion(this, saldo, new Date());
        transaccionesInicializadas.add(transaccion);
        
        this.saldo -= saldo;
    }
    
    public void inicializarTransaccion(Cuenta destino, int saldo, String nombreTitular, String concepto) {
        Transaccion transaccion = new Transaccion(this, destino, nombreTitular, saldo, new Date(), concepto);
        transaccionesInicializadas.add(transaccion);
        
        destino.aplicarTransaccionEntrante(transaccion);
        this.saldo -= saldo;
    }
    
    public void aplicarTransaccionEntrante(Transaccion transaccion) {
        transaccionesEntrantes.add(transaccion);
        this.saldo += transaccion.getSaldo();
    }
    
    public void anadirTransaccionInicializada(Transaccion transaccion) {
        transaccionesInicializadas.add(transaccion);
    }
    
    public void anadirTransaccionEntrante(Transaccion transaccion) {
        transaccionesEntrantes.add(transaccion);
    }
    
    public void retirarDineroCajero(Cuenta cuenta,int retirarDinero){
            LocalDate fecha = LocalDate.now();  
            listaRetirarDinero.add("Sacaste "+ retirarDinero +"€, el "+fecha.toString());  
            int saldo = cuenta.getSaldo();
            int saldoActual = saldo-retirarDinero;
            this.saldo = saldoActual;
    }
    
    public void retirarDineroCheck(String dinero){  
        LocalDate fecha = LocalDate.now();  
        listaRetirarDinero.add("Sacaste "+ dinero +"€, el "+fecha.toString());  

    }
}
