package modelo;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 *
 * @author jonas.schiefner
 */
public class Datos {
    private static List<Cuenta> cuentas;
    
    public static List<Cuenta> getCuentasIniciales() {
        if (cuentas != null) {
            return cuentas;
        }
        
        Cuenta cuentaPablo = new Cuenta("1111", 110, "ES0900759274698567685762");
        Cuenta cuentaJonas = new Cuenta("2222", 100, "DE96500105179925412887");
        
        Transaccion transaccionPabloJonas = new Transaccion(cuentaPablo, cuentaJonas, "Jonas", 10, new Date(), "Comida Cafeteria");
        cuentaPablo.anadirTransaccionInicializada(transaccionPabloJonas);
        cuentaJonas.anadirTransaccionEntrante(transaccionPabloJonas);
        
        Transaccion transaccionJonasPablo = new Transaccion(cuentaJonas, cuentaPablo, "Pablo", 30, new Date(), "Apuesta");
        cuentaJonas.anadirTransaccionInicializada(transaccionJonasPablo);
        cuentaPablo.anadirTransaccionEntrante(transaccionJonasPablo);
        
        Transaccion retiradoPablo = new Transaccion(cuentaPablo, 20, new Date());
        cuentaPablo.anadirTransaccionInicializada(retiradoPablo);
        
        Transaccion retiradoJonas = new Transaccion(cuentaJonas, 50, new Date());
        cuentaJonas.anadirTransaccionInicializada(retiradoJonas);
        
        cuentas = new ArrayList<>(2);
        cuentas.add(cuentaPablo);
        cuentas.add(cuentaJonas);
        
        return cuentas;
    }
    
    public static Cuenta findCuentaConPin(String pin) {
        Cuenta resultado = null;
        for (Cuenta cuenta : getCuentasIniciales()) {
            if (cuenta.getPin().equals(pin)) {
                resultado = cuenta;
                break;
            }
        }
        return resultado;
    }
    
    public static Cuenta findCuentaConIban(String iban) {
        Cuenta resultado = null;
        for (Cuenta cuenta : getCuentasIniciales()) {
            if (cuenta.getIban().equals(iban)) {
                resultado = cuenta;
                break;
            }
        }
        return resultado;
    }
    
    // Devuelve true si el pin del login existe
    public static Boolean findCuentaConPinBoolean(String pin) {
        Cuenta resultado = null;
        for (Cuenta cuenta : getCuentasIniciales()) {
            if (cuenta.getPin().equals(pin)) {
                return true;
                
            }   
        }
        return false;
        
    }

    
}
