/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/GUIForms/JFrame.java to edit this template
 */
package vista;

import componentes.Main;
import controlador.ControladorLogin;
import modelo.Cuenta;


/**
 *
 * @author jonas.schiefner
 */
public class VistaLogin extends javax.swing.JFrame {   
    private final ControladorLogin controlador;
    private Cuenta cuenta;              
    
    
    /**
     * Creates new form VistaPin
     */
    public VistaLogin(Cuenta cuenta) {
        initComponents();
        botonCajeroNormal.setVisible(false);
        botonTransaccion.setVisible(false);
        botonCambiarPin.setVisible(false);
        opcionLabel.setVisible(false);
        opcionLabel.setVisible(false);
        this.controlador = new ControladorLogin(this,cuenta);
    }

    
    /**
     * Para mostrar cuantos intentos quedan para introducir el pin correcto
     * @param intentos string con intentos
     */
     public void setIntentos(String intentos){
        textoIntentos.setText(intentos);
    }
     
     /**
     * Para mostrar un mensaje de error
     * @param texto el mensaje
     */
    public void setMensaje(String texto){
        textoMensaje.setText(texto);
    }
    
    /**
     * Devuelve el pin introducido
     * @return PIN
     */
    public String getTextoPIN(){
        return textoPIN.getText();
    }
    
    /**
     * Para mostrar el pin que entra el usuario
     * @param texto string con el pin actual
     */
    public void setPin(String nuevoPIN){
        textoPIN.setText(nuevoPIN);
    }
    
    /**
     * Pone visible las opciones despues de introducir el pin
     */
    public void visibleOpciones(){
        botonCajeroNormal.setVisible(true);
        botonTransaccion.setVisible(true);
        botonCambiarPin.setVisible(true);
        opcionLabel.setVisible(true);
        opcionLabel.setVisible(true);
    }
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        textoPIN = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        textoIntentos = new javax.swing.JTextField();
        textoMensaje = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        aceptarBoton = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        botonCambiarPin = new javax.swing.JButton();
        botonTransaccion = new javax.swing.JButton();
        botonCajeroNormal = new javax.swing.JButton();
        opcionLabel = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        getContentPane().setLayout(new javax.swing.BoxLayout(getContentPane(), javax.swing.BoxLayout.Y_AXIS));

        jLabel1.setText("Introduzca el PIN");

        jLabel2.setText("PIN:");

        jLabel3.setText("Intentos restantes:");

        jLabel4.setText("Mensaje:");

        aceptarBoton.setText("Aceptar");
        aceptarBoton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aceptarBotonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                        .addContainerGap(106, Short.MAX_VALUE)
                        .addComponent(jLabel2))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                        .addGap(0, 28, Short.MAX_VALUE)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jLabel4)
                            .addComponent(jLabel3))
                        .addGap(4, 4, 4)))
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 141, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(textoIntentos, javax.swing.GroupLayout.DEFAULT_SIZE, 204, Short.MAX_VALUE)
                            .addComponent(textoPIN)
                            .addComponent(textoMensaje))
                        .addGap(105, 105, 105))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(23, 23, 23)
                        .addComponent(aceptarBoton, javax.swing.GroupLayout.PREFERRED_SIZE, 128, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(39, 39, 39)
                .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 26, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(26, 26, 26)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(textoPIN, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2))
                .addGap(18, 18, 18)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(textoIntentos, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel3))
                .addGap(18, 18, 18)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(textoMensaje, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, 22, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(aceptarBoton)
                .addContainerGap(34, Short.MAX_VALUE))
        );

        getContentPane().add(jPanel1);

        jPanel2.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));

        botonCambiarPin.setText("Cambiar Pin");
        botonCambiarPin.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonCambiarPinActionPerformed(evt);
            }
        });

        botonTransaccion.setText("Hacer una transaccion");
        botonTransaccion.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonTransaccionActionPerformed(evt);
            }
        });

        botonCajeroNormal.setText("Cajero normal");
        botonCajeroNormal.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonCajeroNormalActionPerformed(evt);
            }
        });

        opcionLabel.setFont(new java.awt.Font("Segoe UI", 0, 18)); // NOI18N
        opcionLabel.setText("Elige una opcion");

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap(42, Short.MAX_VALUE)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                        .addComponent(botonCajeroNormal)
                        .addGap(18, 18, 18)
                        .addComponent(botonCambiarPin)
                        .addGap(18, 18, 18)
                        .addComponent(botonTransaccion)
                        .addGap(13, 13, 13))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                        .addComponent(opcionLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 185, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(119, 119, 119))))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addContainerGap(54, Short.MAX_VALUE)
                .addComponent(opcionLabel)
                .addGap(35, 35, 35)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(botonTransaccion)
                    .addComponent(botonCambiarPin)
                    .addComponent(botonCajeroNormal))
                .addGap(55, 55, 55))
        );

        getContentPane().add(jPanel2);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void aceptarBotonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aceptarBotonActionPerformed
        controlador.aceptarPIN();
        this.cuenta = controlador.devolverCuenta();
    }//GEN-LAST:event_aceptarBotonActionPerformed

    private void botonCajeroNormalActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonCajeroNormalActionPerformed
        Main.getStateMachine().abrirVistaCajero(cuenta);
    }//GEN-LAST:event_botonCajeroNormalActionPerformed

    private void botonTransaccionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonTransaccionActionPerformed
        Main.getStateMachine().abrirVistaTransacciones(cuenta); //////////////////////
    }//GEN-LAST:event_botonTransaccionActionPerformed

    private void botonCambiarPinActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonCambiarPinActionPerformed
        Main.getStateMachine().abrirVistaCambiarPin(cuenta);
    }//GEN-LAST:event_botonCambiarPinActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton aceptarBoton;
    private javax.swing.JButton botonCajeroNormal;
    private javax.swing.JButton botonCambiarPin;
    private javax.swing.JButton botonTransaccion;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JLabel opcionLabel;
    private javax.swing.JTextField textoIntentos;
    private javax.swing.JTextField textoMensaje;
    private javax.swing.JTextField textoPIN;
    // End of variables declaration//GEN-END:variables
}
